added ikev1/net2net-same-nets scenario
authorAndreas Steffen <andreas.steffen@strongswan.org>
Thu, 9 Sep 2010 11:37:22 +0000 (13:37 +0200)
committerAndreas Steffen <andreas.steffen@strongswan.org>
Thu, 9 Sep 2010 11:37:30 +0000 (13:37 +0200)
testing/tests/ikev1/net2net-same-nets/description.txt [new file with mode: 0644]
testing/tests/ikev1/net2net-same-nets/evaltest.dat [new file with mode: 0644]
testing/tests/ikev1/net2net-same-nets/hosts/moon/etc/ipsec.conf [new file with mode: 0755]
testing/tests/ikev1/net2net-same-nets/hosts/sun/etc/ipsec.conf [new file with mode: 0755]
testing/tests/ikev1/net2net-same-nets/hosts/sun/etc/mark_updown [new file with mode: 0755]
testing/tests/ikev1/net2net-same-nets/posttest.dat [new file with mode: 0644]
testing/tests/ikev1/net2net-same-nets/pretest.dat [new file with mode: 0644]
testing/tests/ikev1/net2net-same-nets/test.conf [new file with mode: 0644]

diff --git a/testing/tests/ikev1/net2net-same-nets/description.txt b/testing/tests/ikev1/net2net-same-nets/description.txt
new file mode 100644 (file)
index 0000000..d0eb337
--- /dev/null
@@ -0,0 +1,15 @@
+A connection between two identical <b>10.0.0.0/14</b> networks behind the gateways <b>moon</b>
+and <b>sun</b> is set up. In order to make network routing work, the subnet behind <b>moon</b>
+sees the subnet behind <b>sun</b> as <b>10.4.0.0/14</b> whereas the subnet behind <b>sun</b>
+sees the subnet behind <b>moon</b> as <b>10.8.0.0/14</b>. The necessary network mappings are
+done on gateway <b>sun</b> using the iptables <b>MARK</b> and <b>NETMAP</b> targets.
+<p/>
+Upon the successful establishment of the IPsec tunnel, on gateway <b>moon</b> the directive
+<b>leftfirewall=yes</b> automatically inserts iptables-based firewall rules that let pass
+the tunneled traffic whereas on gateway <b>sun</b> the script indicated by
+<b>leftupdown=/etc/mark_updown</b> inserts iptables rules that set marks defined in the
+connection definition of <b>ipsec.conf</b> both on the inbound and outbound traffic, create
+the necessary NETMAP operations and forward the tunneled traffic.
+<p/>
+In order to test both tunnel and firewall, client <b>alice</b> behind gateway <b>moon</b>
+pings client <b>bob</b> located behind gateway <b>sun</b> and vice versa.
diff --git a/testing/tests/ikev1/net2net-same-nets/evaltest.dat b/testing/tests/ikev1/net2net-same-nets/evaltest.dat
new file mode 100644 (file)
index 0000000..b5ad062
--- /dev/null
@@ -0,0 +1,10 @@
+moon::ipsec statusall::net-net.*IPsec SA established::YES
+sun::ipsec statusall::net-net.*IPsec SA established::YES
+alice::ping -c 1 10.6.0.10::64 bytes from 10.6.0.10: icmp_seq=1::YES
+bob::ping -c 1 10.9.0.10::64 bytes from 10.9.0.10: icmp_seq=1::YES
+sun::tcpdump::IP moon.strongswan.org > sun.strongswan.org: ESP::YES
+sun::tcpdump::IP sun.strongswan.org > moon.strongswan.org: ESP::YES
+bob::tcpdump::IP 10.9.0.10 > bob.strongswan.org: ICMP echo request::YES
+bob::tcpdump::IP bob.strongswan.org > 10.9.0.10: ICMP echo reply::YES
+bob::tcpdump::IP bob.strongswan.org > 10.9.0.10: ICMP echo request::YES
+bob::tcpdump::IP 10.9.0.10 > bob.strongswan.org: ICMP echo reply::YES 
diff --git a/testing/tests/ikev1/net2net-same-nets/hosts/moon/etc/ipsec.conf b/testing/tests/ikev1/net2net-same-nets/hosts/moon/etc/ipsec.conf
new file mode 100755 (executable)
index 0000000..30af017
--- /dev/null
@@ -0,0 +1,25 @@
+# /etc/ipsec.conf - strongSwan IPsec configuration file
+
+config setup
+        crlcheckinterval=180
+       strictcrlpolicy=no
+       charonstart=no
+       plutodebug=control
+
+conn %default
+       ikelifetime=60m
+       keylife=20m
+       rekeymargin=3m
+       keyingtries=1
+       keyexchange=ikev1
+
+conn net-net 
+       left=PH_IP_MOON
+       leftcert=moonCert.pem
+       leftid=@moon.strongswan.org
+       leftsubnet=10.0.0.0/14
+       leftfirewall=yes
+       right=PH_IP_SUN
+       rightid=@sun.strongswan.org
+       rightsubnet=10.4.0.0/14
+       auto=add
diff --git a/testing/tests/ikev1/net2net-same-nets/hosts/sun/etc/ipsec.conf b/testing/tests/ikev1/net2net-same-nets/hosts/sun/etc/ipsec.conf
new file mode 100755 (executable)
index 0000000..5e924cf
--- /dev/null
@@ -0,0 +1,27 @@
+# /etc/ipsec.conf - strongSwan IPsec configuration file
+
+config setup
+        crlcheckinterval=180
+       strictcrlpolicy=no
+       charonstart=no
+       plutodebug=control
+
+conn %default
+       ikelifetime=60m
+       keylife=20m
+       rekeymargin=3m
+        keyingtries=1
+       keyexchange=ikev1
+
+conn net-net 
+       left=PH_IP_SUN
+       leftcert=sunCert.pem
+       leftid=@sun.strongswan.org
+       leftsubnet=10.4.0.0/14
+       leftupdown=/etc/mark_updown
+       right=PH_IP_MOON
+       rightid=@moon.strongswan.org
+       rightsubnet=10.0.0.0/14
+       mark_in=8
+       mark_out=4
+       auto=add
diff --git a/testing/tests/ikev1/net2net-same-nets/hosts/sun/etc/mark_updown b/testing/tests/ikev1/net2net-same-nets/hosts/sun/etc/mark_updown
new file mode 100755 (executable)
index 0000000..0bfdcad
--- /dev/null
@@ -0,0 +1,376 @@
+#! /bin/sh
+# updown script setting inbound marks on ESP traffic in the mangle chain
+#
+# Copyright (C) 2003-2004 Nigel Meteringham
+# Copyright (C) 2003-2004 Tuomo Soini
+# Copyright (C) 2002-2004 Michael Richardson
+# Copyright (C) 2005-2010 Andreas Steffen <andreas.steffen@strongswan.org>
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the
+# Free Software Foundation; either version 2 of the License, or (at your
+# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# for more details.
+
+# CAUTION:  Installing a new version of strongSwan will install a new
+# copy of this script, wiping out any custom changes you make.  If
+# you need changes, make a copy of this under another name, and customize
+# that, and use the (left/right)updown parameters in ipsec.conf to make
+# strongSwan use yours instead of this default one.
+
+# things that this script gets (from ipsec_pluto(8) man page)
+#
+#      PLUTO_VERSION
+#              indicates  what  version of this interface is being
+#              used.  This document describes version  1.1.   This
+#              is upwardly compatible with version 1.0.
+#
+#       PLUTO_VERB
+#              specifies the name of the operation to be performed
+#              (prepare-host, prepare-client, up-host, up-client,
+#              down-host, or down-client).  If the address family
+#              for security gateway to security gateway communica-
+#              tions is IPv6, then a suffix of -v6 is added to the
+#              verb.
+#
+#       PLUTO_CONNECTION
+#              is the name of the  connection  for  which  we  are
+#              routing.
+#
+#       PLUTO_NEXT_HOP
+#              is the next hop to which packets bound for the peer
+#              must be sent.
+#
+#       PLUTO_INTERFACE
+#              is the name of the ipsec interface to be used.
+#
+#       PLUTO_REQID
+#              is the requid of the ESP policy
+#
+#       PLUTO_ME
+#              is the IP address of our host.
+#
+#       PLUTO_MY_ID
+#              is the ID of our host.
+#
+#       PLUTO_MY_CLIENT
+#              is the IP address / count of our client subnet.  If
+#              the  client  is  just  the  host,  this will be the
+#              host's own IP address / max (where max  is  32  for
+#              IPv4 and 128 for IPv6).
+#
+#       PLUTO_MY_CLIENT_NET
+#              is the IP address of our client net.  If the client
+#              is just the host, this will be the  host's  own  IP
+#              address.
+#
+#       PLUTO_MY_CLIENT_MASK
+#              is  the  mask for our client net.  If the client is
+#              just the host, this will be 255.255.255.255.
+#
+#       PLUTO_MY_SOURCEIP
+#              if non-empty, then the source address for the route will be
+#              set to this IP address.
+#
+#       PLUTO_MY_PROTOCOL
+#              is the IP protocol that will be transported.
+#
+#       PLUTO_MY_PORT
+#              is  the  UDP/TCP  port  to  which  the IPsec SA  is
+#              restricted on our side.
+#
+#       PLUTO_PEER
+#              is the IP address of our peer.
+#
+#       PLUTO_PEER_ID
+#              is the ID of our peer.
+#
+#       PLUTO_PEER_CA
+#              is the CA which issued the cert of our peer.
+#
+#       PLUTO_PEER_CLIENT
+#              is the IP address / count of the peer's client sub-
+#              net.   If the client is just the peer, this will be
+#              the peer's own IP address / max (where  max  is  32
+#              for IPv4 and 128 for IPv6).
+#
+#       PLUTO_PEER_CLIENT_NET
+#              is the IP address of the peer's client net.  If the
+#              client is just the peer, this will  be  the  peer's
+#              own IP address.
+#
+#       PLUTO_PEER_CLIENT_MASK
+#              is  the  mask  for  the  peer's client net.  If the
+#              client   is   just   the   peer,   this   will   be
+#              255.255.255.255.
+#
+#       PLUTO_PEER_PROTOCOL
+#              is the IP protocol that will be transported.
+#
+#       PLUTO_PEER_PORT
+#              is  the  UDP/TCP  port  to  which  the IPsec SA  is
+#              restricted on the peer side.
+#
+#       PLUTO_XAUTH_ID
+#              is an optional user ID employed by the XAUTH protocol
+#
+#       PLUTO_MARK_IN
+#              is an optional XFRM mark set on the inbound IPsec SA
+#
+#       PLUTO_MARK_OUT
+#              is an optional XFRM mark set on the outbound IPsec SA
+#
+#       PLUTO_UDP_ENC
+#              contains the remote UDP port in the case of ESP_IN_UDP
+#              encapsulation
+#
+
+# define a minimum PATH environment in case it is not set
+PATH="/sbin:/bin:/usr/sbin:/usr/bin:/usr/sbin"
+export PATH
+
+# check parameter(s)
+case "$1:$*" in
+':')                   # no parameters
+       ;;
+iptables:iptables)     # due to (left/right)firewall; for default script only
+       ;;
+custom:*)              # custom parameters (see above CAUTION comment)
+       ;;
+*)     echo "$0: unknown parameters \`$*'" >&2
+       exit 2
+       ;;
+esac
+
+# utility functions for route manipulation
+# Meddling with this stuff should not be necessary and requires great care.
+uproute() {
+       doroute add
+       ip route flush cache
+}
+downroute() {
+       doroute delete
+       ip route flush cache
+}
+
+addsource() {
+       st=0
+       if ! ip -o route get ${PLUTO_MY_SOURCEIP%/*} | grep -q ^local
+       then
+           it="ip addr add ${PLUTO_MY_SOURCEIP%/*}/32 dev $PLUTO_INTERFACE"
+           oops="`eval $it 2>&1`"
+           st=$?
+           if test " $oops" = " " -a " $st" != " 0"
+           then
+               oops="silent error, exit status $st"
+           fi
+           if test " $oops" != " " -o " $st" != " 0"
+           then
+               echo "$0: addsource \`$it' failed ($oops)" >&2
+           fi
+       fi
+       return $st
+}
+
+doroute() {
+       st=0
+
+       if [ -z "$PLUTO_MY_SOURCEIP" ]
+       then
+           for dir in /etc/sysconfig /etc/conf.d; do
+               if [ -f "$dir/defaultsource" ]
+               then
+                   . "$dir/defaultsource"
+               fi
+           done
+
+           if [ -n "$DEFAULTSOURCE" ]
+           then
+               PLUTO_MY_SOURCEIP=$DEFAULTSOURCE
+           fi
+        fi
+
+       if [ -z "$KLIPS" -a -z "$PLUTO_MY_SOURCEIP" ]
+       then
+           # leave because no route entry is required
+           return $st
+       fi
+
+       parms1="$PLUTO_PEER_CLIENT"
+
+       if [ -n "$PLUTO_NEXT_HOP" ]
+       then
+           parms2="via $PLUTO_NEXT_HOP"
+       else
+           parms2="via $PLUTO_PEER"
+       fi
+       parms2="$parms2 dev $PLUTO_INTERFACE"
+
+       parms3=
+       if [ -n "$PLUTO_MY_SOURCEIP" ]
+       then
+           if test "$1" = "add"
+           then
+               addsource
+               if ! ip rule list | grep -q "lookup $SOURCEIP_ROUTING_TABLE"
+               then
+                   ip rule add pref $SOURCEIP_ROUTING_TABLE_PRIO table $SOURCEIP_ROUTING_TABLE
+               fi
+           fi
+           parms3="$parms3 src ${PLUTO_MY_SOURCEIP%/*} table $SOURCEIP_ROUTING_TABLE"
+       fi
+
+       case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
+       "0.0.0.0/0.0.0.0")
+               # opportunistic encryption work around
+               # need to provide route that eclipses default, without
+               # replacing it.
+               it="ip route $1 0.0.0.0/1 $parms2 $parms3 &&
+                       ip route $1 128.0.0.0/1 $parms2 $parms3"
+               ;;
+       *)      it="ip route $1 $parms1 $parms2 $parms3"
+               ;;
+       esac
+       oops="`eval $it 2>&1`"
+       st=$?
+       if test " $oops" = " " -a " $st" != " 0"
+       then
+           oops="silent error, exit status $st"
+       fi
+       if test " $oops" != " " -o " $st" != " 0"
+       then
+           echo "$0: doroute \`$it' failed ($oops)" >&2
+       fi
+       return $st
+}
+# define NETMAP
+SAME_NET=$PLUTO_PEER_CLIENT
+IN_NET=$PLUTO_MY_CLIENT
+OUT_NET="10.8.0.0/14"
+
+# define internal interface
+INT_INTERFACE="eth1"
+
+# is there an inbound mark to be set?
+if [ -n "$PLUTO_MARK_IN" ]
+then
+       if [ -n "$PLUTO_UDP_ENC" ]
+       then
+           SET_MARK_IN="-p udp --sport $PLUTO_UDP_ENC"
+       else
+               SET_MARK_IN="-p esp"
+       fi
+       SET_MARK_IN="$SET_MARK_IN -s $PLUTO_PEER -j MARK --set-mark $PLUTO_MARK_IN"
+fi
+
+# is there an outbound mark to be set?
+if [ -n "$PLUTO_MARK_OUT" ]
+then
+       SET_MARK_OUT="-i $INT_INTERFACE -s $SAME_NET -d $OUT_NET -j MARK --set-mark $PLUTO_MARK_OUT"
+fi
+
+# resolve octal escape sequences
+PLUTO_MY_ID=`printf "$PLUTO_MY_ID"`
+PLUTO_PEER_ID=`printf "$PLUTO_PEER_ID"`
+
+# the big choice
+case "$PLUTO_VERB:$1" in
+prepare-host:*|prepare-client:*)
+       if [ -z "$KLIPS" -a -z "$PLUTO_MY_SOURCEIP" ]
+       then
+           # exit because no route will be added,
+           # so that existing routes can stay
+           exit 0
+       fi
+
+       # delete possibly-existing route (preliminary to adding a route)
+       case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
+       "0.0.0.0/0.0.0.0")
+               # need to provide route that eclipses default, without
+               # replacing it.
+               parms1="0.0.0.0/1"
+               parms2="128.0.0.0/1"
+               it="ip route delete $parms1 2>&1 ; ip route delete $parms2 2>&1"
+               oops="`ip route delete $parms1 2>&1 ; ip route delete $parms2 2>&1`"
+               ;;
+       *)
+               parms="$PLUTO_PEER_CLIENT"
+               it="ip route delete $parms 2>&1"
+               oops="`ip route delete $parms 2>&1`"
+               ;;
+       esac
+       status="$?"
+       if test " $oops" = " " -a " $status" != " 0"
+       then
+               oops="silent error, exit status $status"
+       fi
+       case "$oops" in
+       *'RTNETLINK answers: No such process'*)
+               # This is what route (currently -- not documented!) gives
+               # for "could not find such a route".
+               oops=
+               status=0
+               ;;
+       esac
+       if test " $oops" != " " -o " $status" != " 0"
+       then
+               echo "$0: \`$it' failed ($oops)" >&2
+       fi
+       exit $status
+       ;;
+route-host:*|route-client:*)
+       # connection to me or my client subnet being routed
+       uproute
+       ;;
+unroute-host:*|unroute-client:*)
+       # connection to me or my client subnet being unrouted
+       downroute
+       ;;
+up-client:)
+       # connection to my client subnet coming up
+       # If you are doing a custom version, firewall commands go here.
+       if [ -n "$PLUTO_MARK_IN" ]
+       then
+           iptables -t mangle -A PREROUTING $SET_MARK_IN
+           iptables -t nat -A PREROUTING -i $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_IN \
+                    -d $IN_NET -j NETMAP --to $SAME_NET 
+           iptables -I FORWARD 1 -i $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_IN -j ACCEPT
+           iptables -t nat -A POSTROUTING -o $INT_INTERFACE -m mark --mark $PLUTO_MARK_IN \
+                    -s $SAME_NET -j NETMAP --to $OUT_NET 
+       fi
+       if [ -n "$PLUTO_MARK_OUT" ]
+       then
+           iptables -t mangle -A PREROUTING $SET_MARK_OUT 
+           iptables -t nat -A PREROUTING -i $INT_INTERFACE -m mark --mark $PLUTO_MARK_OUT \
+                    -d $OUT_NET -j NETMAP --to $SAME_NET
+           iptables -I FORWARD 1 -o $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_OUT -j ACCEPT
+            iptables -t nat -A POSTROUTING -o $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_OUT \
+                     -s $SAME_NET -j NETMAP --to $IN_NET
+       fi
+       ;;
+down-client:)
+       # connection to my client subnet going down
+       # If you are doing a custom version, firewall commands go here.
+       if [ -n "$PLUTO_MARK_IN" ]
+       then
+           iptables -t mangle -D PREROUTING $SET_MARK_IN
+           iptables -t nat -D PREROUTING -i $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_IN \
+                    -d $IN_NET -j NETMAP --to $SAME_NET 
+           iptables -D FORWARD -i $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_IN -j ACCEPT
+           iptables -t nat -D POSTROUTING -o eth1 -m mark --mark $PLUTO_MARK_IN \
+                    -s $SAME_NET -j NETMAP --to $OUT_NET 
+       fi
+       if [ -n "$PLUTO_MARK_OUT" ]
+       then
+           iptables -t mangle -D PREROUTING $SET_MARK_OUT
+           iptables -D FORWARD -o $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_OUT -j ACCEPT
+       fi
+       ;;
+*)     echo "$0: unknown verb \`$PLUTO_VERB' or parameter \`$1'" >&2
+       exit 1
+       ;;
+esac
diff --git a/testing/tests/ikev1/net2net-same-nets/posttest.dat b/testing/tests/ikev1/net2net-same-nets/posttest.dat
new file mode 100644 (file)
index 0000000..e75e666
--- /dev/null
@@ -0,0 +1,7 @@
+sun::iptables -t mangle -n -v -L PREROUTING
+sun::iptables -t nat -n -v -L
+moon::ipsec stop
+sun::ipsec stop
+moon::/etc/init.d/iptables stop 2> /dev/null
+sun::/etc/init.d/iptables stop 2> /dev/null
+sun::conntrack -F
diff --git a/testing/tests/ikev1/net2net-same-nets/pretest.dat b/testing/tests/ikev1/net2net-same-nets/pretest.dat
new file mode 100644 (file)
index 0000000..2d7a78a
--- /dev/null
@@ -0,0 +1,6 @@
+moon::/etc/init.d/iptables start 2> /dev/null
+sun::/etc/init.d/iptables start 2> /dev/null
+moon::ipsec start
+sun::ipsec start
+moon::sleep 1 
+moon::ipsec up net-net
diff --git a/testing/tests/ikev1/net2net-same-nets/test.conf b/testing/tests/ikev1/net2net-same-nets/test.conf
new file mode 100644 (file)
index 0000000..1971a33
--- /dev/null
@@ -0,0 +1,21 @@
+#!/bin/bash
+#
+# This configuration file provides information on the
+# UML instances used for this test
+
+# All UML instances that are required for this test
+#
+UMLHOSTS="alice moon winnetou sun bob"
+
+# Corresponding block diagram
+#
+DIAGRAM="a-m-w-s-b.png"
+# UML instances on which tcpdump is to be started
+#
+TCPDUMPHOSTS="sun bob"
+
+# UML instances on which IPsec is started
+# Used for IPsec logging purposes
+#
+IPSECHOSTS="moon sun"